Loading...
Searching...
No Matches
BALL::CrystalGenerator Class Reference
Molecular Modeling » X-Ray Crystallography

`#include <BALL/XRAY/crystalGenerator.h>`

## Classes

struct | Option
struct | Default

## Public Types

Enums
enum | CellType { NCS_ASU = 0 , ASU = 1 , UNITCELL = 2 }

## constructors and Destructors

GeometricCenterProcessor | center_processor_
TransformationProcessor | transformer_
System * | system_
System * | asu_
System * | unitcell_
boost::shared_ptr< CrystalInfo > | ci_ptr_
String | filename_
| CrystalGenerator ()
| CrystalGenerator (const CrystalGenerator &cg)
| ~CrystalGenerator ()
void | setSpaceGroupFilename (String &filename)
const String & | getSpaceGroupFilename () const
void | setCrystalInfo (boost::shared_ptr< CrystalInfo > ci_ptr)
void | setSystem (System *system_ptr)
std::list< System * > | generatePacking (Index a_loweridx, Index a_upperidx, Index b_loweridx, Index b_upperid, Index c_loweridx, Index c_upperid)
System * | generateUnitCell (Index a, Index b, Index c)
System * | generateUnitCell ()
System * | generateAsymmetricUnit ()
std::list< System * > | generateSymMoleculesWithinDistance (float angstrom)
Box3 | getUnitCellBox (Index a, Index b, Index c)
bool | buildUnitCell_ ()
bool | buildASU_ ()
bool | correctASUPositions_ (System *raw_cell)

## Detailed Description

CrystalGenerator Class

Definition at line 40 of file crystalGenerator.h.

## Member Enumeration Documentation

## CellType

enum BALL::CrystalGenerator::CellType

Enumerator
NCS_ASU |
ASU |
UNITCELL |

Definition at line 51 of file crystalGenerator.h.

## Constructor & Destructor Documentation

## CrystalGenerator() [1/2]

BALL::CrystalGenerator::CrystalGenerator | ( |  | ) |

Default Constructor. This methods creates a new CrystalGenerator object

## CrystalGenerator() [2/2]

BALL::CrystalGenerator::CrystalGenerator | ( | const CrystalGenerator & | cg | ) |

Copy Constructor. Creates a new CrystalGenerator object from another

Parameters

  cg | the CrystalGenerator to be copied from

## ~CrystalGenerator()

BALL::CrystalGenerator::~CrystalGenerator | ( |  | ) |

Destructor.

## Member Function Documentation

## buildASU_()

bool BALL::CrystalGenerator::buildASU_ | ( |  | ) |

protected

## buildUnitCell_()

bool BALL::CrystalGenerator::buildUnitCell_ | ( |  | ) |

protected

## correctASUPositions_()

bool BALL::CrystalGenerator::correctASUPositions_ | ( | System * | raw_cell | ) |

protected

## generateAsymmetricUnit()

System * BALL::CrystalGenerator::generateAsymmetricUnit | ( |  | ) |

## generatePacking()

std::list< System * > BALL::CrystalGenerator::generatePacking | ( | Index | a_loweridx,
|  | Index | a_upperidx,
|  | Index | b_loweridx,
|  | Index | b_upperid,
|  | Index | c_loweridx,
|  | Index | c_upperid )

## generateSymMoleculesWithinDistance()

std::list< System * > BALL::CrystalGenerator::generateSymMoleculesWithinDistance | ( | float | angstrom | ) |

## generateUnitCell() [1/2]

System * BALL::CrystalGenerator::generateUnitCell | ( |  | ) |

## generateUnitCell() [2/2]

System * BALL::CrystalGenerator::generateUnitCell | ( | Index | a,
|  | Index | b,
|  | Index | c )

## getSpaceGroupFilename()

const String & BALL::CrystalGenerator::getSpaceGroupFilename | ( |  | ) | const

inline

Definition at line 101 of file crystalGenerator.h.

## getUnitCellBox()

Box3 BALL::CrystalGenerator::getUnitCellBox | ( | Index | a,
|  | Index | b,
|  | Index | c )

## setCrystalInfo()

void BALL::CrystalGenerator::setCrystalInfo | ( | boost::shared_ptr< CrystalInfo > | ci_ptr | ) |

## setSpaceGroupFilename()

void BALL::CrystalGenerator::setSpaceGroupFilename | ( | String & | filename | ) |

inline

Definition at line 98 of file crystalGenerator.h.

## setSystem()

void BALL::CrystalGenerator::setSystem | ( | System * | system_ptr | ) |

## Member Data Documentation

## asu_

System* BALL::CrystalGenerator::asu_

protected

Definition at line 125 of file crystalGenerator.h.

## center_processor_

GeometricCenterProcessor BALL::CrystalGenerator::center_processor_

protected

Definition at line 120 of file crystalGenerator.h.

## ci_ptr_

boost::shared_ptr<CrystalInfo> BALL::CrystalGenerator::ci_ptr_

protected

Definition at line 127 of file crystalGenerator.h.

## filename_

String BALL::CrystalGenerator::filename_

protected

Definition at line 128 of file crystalGenerator.h.

## system_

System* BALL::CrystalGenerator::system_

protected

Definition at line 123 of file crystalGenerator.h.

## transformer_

TransformationProcessor BALL::CrystalGenerator::transformer_

protected

Definition at line 121 of file crystalGenerator.h.

## unitcell_

System* BALL::CrystalGenerator::unitcell_

protected

Definition at line 126 of file crystalGenerator.h.